import { useTypes } from 'over';

const types = {
   number: (x: unknown): x is number => typeof x === 'number',
   bigint: (x: unknown): x is bigint => typeof x === 'bigint'
}

const overload = useTypes(types)

const add = overload({
   'number,number -> number': (a,b) => {
      console.log('Adding numbers', a, b)
      return a+b
   },
   'bigint,bigint -> bigint': (a,b) => {
      console.log('Adding bigints', a, b)
      return a+b
   }
})

console.log('Sum of 5 and 7 is', add(5,7))
console.log('Sum of 5n and 7n is', add(5n, 7n))
